-module(gluple@transform).
-compile([no_auto_import, nowarn_unused_vars, nowarn_unused_function, nowarn_nomatch]).

-export([replace_last1/2, replace_last2/2, replace_last3/2, replace_last4/2, replace_last5/2, replace_last6/2, replace_last7/2, replace_last8/2, replace_last9/2, with_replace_last1/2, with_replace_last2/2, with_replace_last3/2, with_replace_last4/2, with_replace_last5/2, with_replace_last6/2, with_replace_last7/2, with_replace_last8/2, with_replace_last9/2]).

-spec replace_last1({any()}, JPC) -> {JPC}.
replace_last1(_, Data) ->
    {Data}.

-spec replace_last2({JPD, any()}, JPF) -> {JPD, JPF}.
replace_last2(Tuple, Data) ->
    {erlang:element(1, Tuple), Data}.

-spec replace_last3({JPG, JPH, any()}, JPJ) -> {JPG, JPH, JPJ}.
replace_last3(Tuple, Data) ->
    {erlang:element(1, Tuple), erlang:element(2, Tuple), Data}.

-spec replace_last4({JPK, JPL, JPM, any()}, JPO) -> {JPK, JPL, JPM, JPO}.
replace_last4(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        Data}.

-spec replace_last5({JPP, JPQ, JPR, JPS, any()}, JPU) -> {JPP,
    JPQ,
    JPR,
    JPS,
    JPU}.
replace_last5(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        Data}.

-spec replace_last6({JPV, JPW, JPX, JPY, JPZ, any()}, JQB) -> {JPV,
    JPW,
    JPX,
    JPY,
    JPZ,
    JQB}.
replace_last6(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        Data}.

-spec replace_last7({JQC, JQD, JQE, JQF, JQG, JQH, any()}, JQJ) -> {JQC,
    JQD,
    JQE,
    JQF,
    JQG,
    JQH,
    JQJ}.
replace_last7(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        Data}.

-spec replace_last8({JQK, JQL, JQM, JQN, JQO, JQP, JQQ, any()}, JQS) -> {JQK,
    JQL,
    JQM,
    JQN,
    JQO,
    JQP,
    JQQ,
    JQS}.
replace_last8(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        erlang:element(7, Tuple),
        Data}.

-spec replace_last9({JQT, JQU, JQV, JQW, JQX, JQY, JQZ, JRA, any()}, JRC) -> {JQT,
    JQU,
    JQV,
    JQW,
    JQX,
    JQY,
    JQZ,
    JRA,
    JRC}.
replace_last9(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        erlang:element(7, Tuple),
        erlang:element(8, Tuple),
        Data}.

-spec with_replace_last1({JRD}, fun((JRD) -> JRE)) -> {JRE}.
with_replace_last1(Tuple, Cb) ->
    {Cb(erlang:element(1, Tuple))}.

-spec with_replace_last2({JRF, JRG}, fun((JRF, JRG) -> JRH)) -> {JRF, JRH}.
with_replace_last2(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        Cb(erlang:element(1, Tuple), erlang:element(2, Tuple))}.

-spec with_replace_last3({JRI, JRJ, JRK}, fun((JRI, JRJ, JRK) -> JRL)) -> {JRI,
    JRJ,
    JRL}.
with_replace_last3(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple)
        )}.

-spec with_replace_last4({JRM, JRN, JRO, JRP}, fun((JRM, JRN, JRO, JRP) -> JRQ)) -> {JRM,
    JRN,
    JRO,
    JRQ}.
with_replace_last4(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple)
        )}.

-spec with_replace_last5(
    {JRR, JRS, JRT, JRU, JRV},
    fun((JRR, JRS, JRT, JRU, JRV) -> JRW)
) -> {JRR, JRS, JRT, JRU, JRW}.
with_replace_last5(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple),
            erlang:element(5, Tuple)
        )}.

-spec with_replace_last6(
    {JRX, JRY, JRZ, JSA, JSB, JSC},
    fun((JRX, JRY, JRZ, JSA, JSB, JSC) -> JSD)
) -> {JRX, JRY, JRZ, JSA, JSB, JSD}.
with_replace_last6(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple),
            erlang:element(5, Tuple),
            erlang:element(6, Tuple)
        )}.

-spec with_replace_last7(
    {JSE, JSF, JSG, JSH, JSI, JSJ, JSK},
    fun((JSE, JSF, JSG, JSH, JSI, JSJ, JSK) -> JSL)
) -> {JSE, JSF, JSG, JSH, JSI, JSJ, JSL}.
with_replace_last7(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple),
            erlang:element(5, Tuple),
            erlang:element(6, Tuple),
            erlang:element(7, Tuple)
        )}.

-spec with_replace_last8(
    {JSM, JSN, JSO, JSP, JSQ, JSR, JSS, JST},
    fun((JSM, JSN, JSO, JSP, JSQ, JSR, JSS, JST) -> JSU)
) -> {JSM, JSN, JSO, JSP, JSQ, JSR, JSS, JSU}.
with_replace_last8(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        erlang:element(7, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple),
            erlang:element(5, Tuple),
            erlang:element(6, Tuple),
            erlang:element(7, Tuple),
            erlang:element(8, Tuple)
        )}.

-spec with_replace_last9(
    {JSV, JSW, JSX, JSY, JSZ, JTA, JTB, JTC, JTD},
    fun((JSV, JSW, JSX, JSY, JSZ, JTA, JTB, JTC, JTD) -> JTE)
) -> {JSV, JSW, JSX, JSY, JSZ, JTA, JTB, JTC, JTE}.
with_replace_last9(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        erlang:element(7, Tuple),
        erlang:element(8, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple),
            erlang:element(5, Tuple),
            erlang:element(6, Tuple),
            erlang:element(7, Tuple),
            erlang:element(8, Tuple),
            erlang:element(9, Tuple)
        )}.
